## Tool: `run_home_actions`

Executes a list of actions on one or more resources. Should follow command format from list_home_resources.

The following code sample shows how to use `curl` to call the `run_home_actions` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://home.googleapis.com/mcp' \ --header 'Authorization: Bearer {oauth-access-token}' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "run_home_actions", "arguments": { // Provide these details according to the MCP tool specification. } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

Request for ExecuteHomeActions.

### ExecuteHomeActionsRequest

| JSON representation |
|---|
| ``` { "structureId": string, "homeActionRequests": [ { object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Input.Schema.HomeActionRequest`) } ] } ``` |

| Fields ||
|---|---|
| `structureId` | `string` Required. The unique identifier for the structure to execute the actions in. |
| `homeActionRequests[]` | ``object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Input.Schema.HomeActionRequest`)`` The list of actions to execute. |

### HomeActionRequest

| JSON representation |
|---|
| ``` { "id": string, "type": string, "command": string, "parameters": { object }, "challengeResponse": { object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Input.Schema.ChallengeResponse`) } } ``` |

| Fields ||
|---|---|
| `id` | `string` Required. The ID of the resource on which to execute the action on. |
| `type` | `string` Required. The type of the resource. This is the type returned from DiscoverHomeResources. |
| `command` | `string` Required. The name of the command to execute (e.g. "OnOff.On"). |
| `parameters` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` Optional. The parameters for the action, as a struct. The keys must match the parameter names in the metadata's CommandDefinition. Example: {"level": 50} |
| `challengeResponse` | ``object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Input.Schema.ChallengeResponse`)`` Optional. The credential provided by the user in response to a 2FA challenge. |

### Struct

| JSON representation |
|---|
| ``` { "fields": { string: value, ... } } ``` |

| Fields ||
|---|---|
| `fields` | ``map (key: string, value: value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format))`` Unordered map of dynamically typed values. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### FieldsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": value } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` |

### Value

| JSON representation |
|---|
| ``` { // Union field `kind` can be only one of the following: "nullValue": null, "numberValue": number, "stringValue": string, "boolValue": boolean, "structValue": { object }, "listValue": array // End of list of possible types for union field `kind`. } ``` |

| Fields ||
|---|---|
| Union field `kind`. The kind of value. `kind` can be only one of the following: ||
| `nullValue` | `null` Represents a JSON `null`. |
| `numberValue` | `number` Represents a JSON number. Must not be `NaN`, `Infinity` or `-Infinity`, since those are not supported in JSON. This also cannot represent large Int64 values, since JSON format generally does not support them in its number type. |
| `stringValue` | `string` Represents a JSON string. |
| `boolValue` | `boolean` Represents a JSON boolean (`true` or `false` literal in JSON). |
| `structValue` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` Represents a JSON object. |
| `listValue` | ``array (`https://protobuf.dev/reference/protobuf/google.protobuf#list-value` format)`` Represents a JSON array. |
|   ||

### ListValue

| JSON representation |
|---|
| ``` { "values": [ value ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` Repeated field of dynamically typed values. |

### ChallengeResponse

| JSON representation |
|---|
| ``` { // Union field `credential` can be only one of the following: "pin": string, "ack": boolean, "passphrase": string // End of list of possible types for union field `credential`. } ``` |

| Fields ||
|---|---|
| Union field `credential`. The specific credential payload based on the challenge type. `credential` can be only one of the following: ||
| `pin` | `string` Optional. For PIN_NEEDED or CHALLENGE_FAILED_PIN_NEEDED. |
| `ack` | `boolean` Optional. For ACK_NEEDED. |
| `passphrase` | `string` Optional. For PASSPHRASE_NEEDED or CHALLENGE_FAILED_PASSPHRASE_NEEDED. |
|   ||

### NullValue

Represents a JSON `null`.

`NullValue` is a sentinel, using an enum with only one value to represent the null value for the `Value` type union.

A field of type `NullValue` with any value other than `0` is considered invalid. Most ProtoJSON serializers will emit a `Value` with a `null_value` set as a JSON `null` regardless of the integer value, and so will round trip to a `0` value.

| Enums ||
|---|---|
| `NULL_VALUE` | Null value. |

## Output Schema

Response for ExecuteHomeActions.

### ExecuteHomeActionsResponse

| JSON representation |
|---|
| ``` { "homeActionResponses": [ { object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Output.Schema.HomeActionResponse`) } ] } ``` |

| Fields ||
|---|---|
| `homeActionResponses[]` | ``object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Output.Schema.HomeActionResponse`)`` The responses from the action execution requests. |

### HomeActionResponse

| JSON representation |
|---|
| ``` { "id": string, // Union field `response_type` can be only one of the following: "response": { object }, "error": { object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Output.Schema.Status`) } // End of list of possible types for union field `response_type`. } ``` |

| Fields ||
|---|---|
| `id` | `string` Output only. The ID of the resource on which the action executed. |
| Union field `response_type`. The result of the action execution. `response_type` can be only one of the following: ||
| `response` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` The successful response payload. |
| `error` | ``object (`https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions#Output.Schema.Status`)`` The error details if the action execution failed. |
|   ||

### Struct

| JSON representation |
|---|
| ``` { "fields": { string: value, ... } } ``` |

| Fields ||
|---|---|
| `fields` | ``map (key: string, value: value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format))`` Unordered map of dynamically typed values. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### FieldsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": value } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` |

### Value

| JSON representation |
|---|
| ``` { // Union field `kind` can be only one of the following: "nullValue": null, "numberValue": number, "stringValue": string, "boolValue": boolean, "structValue": { object }, "listValue": array // End of list of possible types for union field `kind`. } ``` |

| Fields ||
|---|---|
| Union field `kind`. The kind of value. `kind` can be only one of the following: ||
| `nullValue` | `null` Represents a JSON `null`. |
| `numberValue` | `number` Represents a JSON number. Must not be `NaN`, `Infinity` or `-Infinity`, since those are not supported in JSON. This also cannot represent large Int64 values, since JSON format generally does not support them in its number type. |
| `stringValue` | `string` Represents a JSON string. |
| `boolValue` | `boolean` Represents a JSON boolean (`true` or `false` literal in JSON). |
| `structValue` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` Represents a JSON object. |
| `listValue` | ``array (`https://protobuf.dev/reference/protobuf/google.protobuf#list-value` format)`` Represents a JSON array. |
|   ||

### ListValue

| JSON representation |
|---|
| ``` { "values": [ value ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` Repeated field of dynamically typed values. |

### Status

| JSON representation |
|---|
| ``` { "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } ``` |

| Fields ||
|---|---|
| `code` | `integer` The status code, which should be an enum value of `google.rpc.Code`. |
| `message` | `string` A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the `google.rpc.Status.details` field, or localized by the client. |
| `details[]` | `object` A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |

### Any

| JSON representation |
|---|
| ``` { "typeUrl": string, "value": string } ``` |

| Fields ||
|---|---|
| `typeUrl` | `string` Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one `/` character, and the content after the last `/` must be the fully-qualified name of the type in canonical form, without a leading dot. Do not write a scheme on these URI references so that clients do not attempt to contact them. The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last `/` to identify the type. `type.googleapis.com/` is a common default prefix that some legacy implementations require. This prefix does not indicate the origin of the type, and URIs containing it are not expected to respond to any requests. All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): `/-.~_!$&()*+,;=`. Despite our allowing percent encodings, implementations should not unescape them to prevent confusion with existing parsers. For example, `type.googleapis.com%2FFoo` should be rejected. In the original design of `Any`, the possibility of launching a type resolution service at these type URLs was considered but Protobuf never implemented one and considers contacting these URLs to be problematic and a potential security issue. Do not attempt to contact type URLs. |
| `value` | `string (https://developers.google.com/discovery/v1/type-format format)` Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |

### NullValue

Represents a JSON `null`.

`NullValue` is a sentinel, using an enum with only one value to represent the null value for the `Value` type union.

A field of type `NullValue` with any value other than `0` is considered invalid. Most ProtoJSON serializers will emit a `Value` with a `null_value` set as a JSON `null` regardless of the integer value, and so will round trip to a `0` value.

| Enums ||
|---|---|
| `NULL_VALUE` | Null value. |

### Tool Annotations


[Tool annotations](https://modelcontextprotocol.io/specification/latest/schema#toolannotations) are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.


Along with the title string, the following boolean hints are defined as follows:

- `readOnlyHint`: If true, the tool doesn't modify its environment. Default: false.
- `destructiveHint`: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
- `idempotentHint`: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
- `openWorldHint`: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ✅ \| Idempotent Hint: ❌ \| Read Only Hint: ❌ \| Open World Hint: ✅